<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JFile.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler</a> &gt; <span class="el_source">JFile.java</span></div><h1>JFile.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

/**
 * Container for the Hadoop Record DDL.
 * The main components of the file are filename, list of included files,
 * and records defined in that file.
 *
 */
public class JFile {
    
    private String mName;
    private ArrayList&lt;JFile&gt; mInclFiles;
    private ArrayList&lt;JRecord&gt; mRecords;
    
    /** Creates a new instance of JFile
     *
     * @param name possibly full pathname to the file
     * @param inclFiles included files (as JFile)
     * @param recList List of records defined within this file
     */
    public JFile(String name, ArrayList&lt;JFile&gt; inclFiles,
            ArrayList&lt;JRecord&gt; recList)
<span class="nc" id="L45">    {</span>
<span class="nc" id="L46">        mName = name;</span>
<span class="nc" id="L47">        mInclFiles = inclFiles;</span>
<span class="nc" id="L48">        mRecords = recList;</span>
<span class="nc" id="L49">    }</span>
    
    /** Strip the other pathname components and return the basename */
    String getName() {
<span class="nc" id="L53">        int idx = mName.lastIndexOf('/');</span>
<span class="nc bnc" id="L54" title="All 2 branches missed.">        return (idx &gt; 0) ? mName.substring(idx) : mName; </span>
    }
    
    /** Generate record code in given language. Language should be all
     *  lowercase.
     * @param outputDirectory 
     */
    public void genCode(String language, File outputDirectory)
        throws IOException
    {
<span class="nc bnc" id="L64" title="All 2 branches missed.">        if (&quot;c++&quot;.equals(language)) {</span>
<span class="nc" id="L65">            CppGenerator gen = new CppGenerator(mName, mInclFiles, mRecords,</span>
                    outputDirectory);
<span class="nc" id="L67">            gen.genCode();</span>
<span class="nc bnc" id="L68" title="All 2 branches missed.">        } else if (&quot;java&quot;.equals(language)) {</span>
<span class="nc" id="L69">            JavaGenerator gen = new JavaGenerator(mName, mInclFiles, mRecords,</span>
                    outputDirectory);
<span class="nc" id="L71">            gen.genCode();</span>
<span class="nc bnc" id="L72" title="All 2 branches missed.">        } else if (&quot;c&quot;.equals(language)) {</span>
<span class="nc" id="L73">        	CGenerator gen = new CGenerator(mName, mInclFiles, mRecords,</span>
        	        outputDirectory);
<span class="nc" id="L75">        	gen.genCode();</span>
<span class="nc bnc" id="L76" title="All 2 branches missed.">        } else if (&quot;csharp&quot;.equals(language)) {</span>
<span class="nc" id="L77">        	CSharpGenerator gen = new CSharpGenerator(mName, mInclFiles, mRecords,</span>
        	        outputDirectory);
<span class="nc" id="L79">        	gen.genCode();</span>
<span class="nc" id="L80">        } else {</span>
<span class="nc" id="L81">            throw new IOException(&quot;Cannnot recognize language:&quot; + language);</span>
        }
<span class="nc" id="L83">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>